require 'net/http'
require 'json'
require 'yaml'

module CoinHelper
  module Tasks
    MAX_RAW_COINS     = 2000
    MAX_COINS         = 500
    MAX_POPULAR_COINS = 50
    COIN_DATA_URL     = "https://api.coinlore.net/api/tickers/?start=%i&limit=%i"
    COIN_DATA_BATCH   = 100
    CARBON_URL        = "https://www.cryptowisser.com/crypto-carbon-footprint"
    ROOT_PATH         = File.expand_path('../../..', __FILE__)
    CARBON_YAML       = File.join(ROOT_PATH, '/data/carbon.yml')
    COINS_YAML        = File.join(ROOT_PATH, '/data/coins.yml')
    CUSTOM_COINS_YAML = File.join(ROOT_PATH, '/data/custom_coins.yml')
    ICON_DIRECTORY    = File.join(ROOT_PATH, '/app/assets/images/coin_helper')
    SVG_DIRECTORY     = File.join(ROOT_PATH, '/data/svg')
    DATA_RB           = File.join(ROOT_PATH, '/lib/coin_helper/data.rb')
    ICON_SOURCE       = File.join(ROOT_PATH, '/data/svg/color')
    ICON_SOURCE2      = File.join(ROOT_PATH, '/data/other_svg')
    ICON_SIZES        = ["22"]
    ICON_COLORS       = ["color"]

    KNOWN_STABLE      = ["USDC", "BUSD", "USDT"]
    KNOWN_GREEN       = ["XNO", "NANO"]
    KNOWN_PRIVATE     = ["XMR", "ZEC", "PIVX", "KMD", "FIRO", "NAV", "ZEN", "XVG", "PART", "BTCP", "ONION"]

    class << self
      def icon_path(coin, color, size)
        File.join(ICON_DIRECTORY, color, size, coin + '.png')
      end

      def icon_exists?(coin)
        File.exist? File.join(ICON_DIRECTORY, 'color', '22', coin.downcase + '.png')
      end

      def run(cmd)
        system(cmd + ' >/dev/null 2>/dev/null')
        unless $? == 0
          puts "ERROR: failed to run #{cmd}"
          puts "bailing out."
          exit
        end
      end

      def render_png(src, dst, size)
        options = []
        options << "--file='#{src}'"
        options << "--export-png='#{dst}'"
        #options << "--export-background=0xffffff"
        options << "--export-background-opacity=0x00"
        options << "-w #{size}"
        options << "-h #{size}"
        run("inkscape #{options.join ' '}")
        run("optipng #{dst}")
      end

      def render_coin_icons
        icon_paths = Dir.glob(ICON_SOURCE + '/*.svg') + Dir.glob(ICON_SOURCE2 + '/*.svg')
        icon_paths.each do |svg_icon_path|
          ICON_SIZES.each do |size|
            coin = File.basename(svg_icon_path).sub('.svg', '')
            dest_file = icon_path(coin, 'color', size)
            if ENV["FORCE"] || !File.exist?(dest_file)
              puts "render #{dest_file}"
              render_png(svg_icon_path, dest_file, size)
            end
          end
        end
      end

      def update_coin_data
        batches = []
        i = 0
        while true
          begin
            batch_url = COIN_DATA_URL % [i, COIN_DATA_BATCH]
            i += COIN_DATA_BATCH
            puts "FETCH #{batch_url}"
            resp = Net::HTTP.get_response(URI.parse(batch_url))
            data = JSON.parse(resp.body)["data"]
            if i > MAX_RAW_COINS || data.empty?
              break
            else
              batches << data
            end
          rescue StandardError
          end
        end
        File.open(COINS_YAML, 'w') do |f|
          f.puts '---'
          batches.each do |coins|
            coins.each do |coin|
              f.puts "\"#{coin["symbol"]}\":"
              f.puts "  name: \"#{coin["name"]}\""
              f.puts "  rank: #{coin["rank"]}"
            end
          end
        end
      end

      DATA_HEADER = %[# do not edit this file. it is auto-generated\nmodule CoinHelper]

      DATA_COIN = \
%[    "%{symbol}" => {
      "name" => {
        "en" => "%{name}"
      },
      "icon" => "%{icon}",
      "rank" => %{rank},
      "carbon" => "%{carbon}",
      "stable" => %{stable},
      "private" => %{private}
    },]

      UNKNOWN_COIN = \
%[    "UNKNOWN" => {
      "name" => {
        "en" => "Unknown"
      },
      "icon" => "generic",
      "rank" => %{rank}
    }]

      DATA_FOOTER = %[end]

      def build
        count = 0
        carbon = YAML.load_file(CARBON_YAML)
        coins = YAML.load_file(COINS_YAML).merge(YAML.load_file(CUSTOM_COINS_YAML))
        coins = Hash[coins.sort {|a, b| a.last["rank"] <=> b.last["rank"]}]

        File.open(DATA_RB, 'w') do |f|
          f.puts DATA_HEADER

          f.puts "  CARBON_A = %s" % carbon.select {|k,v| v == "A"}.keys.inspect
          f.puts "  CARBON_B = %s" % carbon.select {|k,v| v == "B"}.keys.inspect
          f.puts "  STABLE = %s"   % coins.select {|k,v| v["stable"] || KNOWN_STABLE.include?(k) }.keys.inspect
          f.puts "  PRIVATE = %s"   % coins.select {|k,v| v["private"] || KNOWN_PRIVATE.include?(k) }.keys.inspect

          f.puts "  DATA = {"
          coins.each do |symbol, data|
            symbol = symbol.to_s.upcase
            if data['icon']
              icon = data['icon']
            elsif icon_exists?(symbol)
              icon = symbol.downcase
            else
              icon = "generic"
            end
            f.puts DATA_COIN % {
              symbol: symbol, name: data['name'],
              rank: data['rank'], icon: icon,
              carbon: carbon[symbol],
              stable: (data['stable'] || KNOWN_STABLE.include?(symbol)),
              private: (data['private'] || KNOWN_PRIVATE.include?(symbol))
            }
            count += 1
            break if count > MAX_COINS
          end
          f.puts UNKNOWN_COIN % {rank: 10000000}
          f.puts "  }"

          f.puts DATA_FOOTER
        end
      end

      def update_carbon_data
        require 'nokogiri'
        require 'open-uri'
        coins = {}
        file = CARBON_URL =~ /^http/ ? URI.open(CARBON_URL) : File.open(CARBON_URL)
        doc = Nokogiri::HTML(file)

        # parse the web page
        doc.css('table.w-full tr').each do |row|
          tds = row.css('td')
          if tds.any?
            symbol = tds[0].content.strip
            rating = tds[1].content.strip
            coins[symbol] = case rating
              when "True Green"   then "A"
              when "Medium Green" then "B"
              when "Light Green"  then "C"
              when "Beige"        then "D"
              when "Brown"        then "F"
              else "N/A"
            end
          end
        end

        # add custom tokens (known to be green but not included)
        KNOWN_GREEN.each do |sym|
          coins[sym] = "A"
        end

        # save the data
        File.open(CARBON_YAML, 'w') do |f|
          f.write(coins.to_yaml)
        end
      end
    end
  end
end